#include <bits/stdc++.h>

using namespace std;

using ll = long long;

int to_int(char c) {
    switch (c) {
        case '0': return 0;
        case '1': return 1;
        case '2': return 2;
        case '3': return 3;
        case '4': return 4;
        case '5': return 5;
        case '6': return 6;
        case '7': return 7;
        case '8': return 8;
        case '9': return 9;
    }
}

char to_char(int i) {
    switch (i) {
        case 0: return '0';
        case 1: return '1';
        case 2: return '2';
        case 3: return '3';
        case 4: return '4';
        case 5: return '5';
        case 6: return '6';
        case 7: return '7';
        case 8: return '8';
        case 9: return '9';
    }
}

char get_max(char a, char b) {
    return to_char(max(to_int(a), to_int(b)));
}

char get_min(char a, char b) {
    return to_char(min(to_int(a), to_int(b)));
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    string a, b;
    cin >> a >> b;

    string s1;

    if (a.size() < b.size()) {
        swap(a, b);
    }
    int asz = a.size();
    int bsz = b.size();

    for (int i = 0; i < asz - bsz; i++) {
        s1 += a[i];
    }
    for (int i = asz - bsz; i < asz; i++) {
        s1 += get_max(a[i], b[i - asz + bsz]);
    }

    string s2;
    for (int i = 0; i < asz + bsz - 1; i++) {
        s2 += '0';
    }

    for (int i = asz - 1; i >= 0; i--) {
        for (int j = bsz - 1; j >= 0; j--) {
            s2[i + j] = get_max(s2[i + j], get_min(a[i], b[j]));
        }
    }
    cout << s1 << " " << s2 << endl;
}
