#include <bits/stdc++.h>
#include <pstl/utils.h>

using namespace std;

using ll = long long;

vector<set<int>> g;

int ohr[300005];

void dfs(int v, int h, set<int> &used) {
    used.insert(v);
    ohr[v] = h + 1;
    if (h == 0) {
        return;
    }
    for (int u : g[v]) {
        if (!used.contains(u) && ohr[u] > h - 2) {
            dfs(u, h - 1, used);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;

    g.resize(n + 1);

    for (int i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        g[a - 1].insert(b - 1);
        g[b - 1].insert(a - 1);
    }

    for (int i = 0; i < k; i++) {
        int p, h;
        set<int> used;
        cin >> p >> h;
        dfs(p - 1, h, used);
    }
    int ans = 0;
    set<int> res;
    for (int i = 0; i < n + 1; i++) {
        if (ohr[i]) {
            ans++;
            res.insert(i);
        }
    }
    cout << ans << endl;
    for (int u : res) {
        cout << u + 1 << ' ';
    }
}
