#include <bits/stdc++.h>
#include <pstl/utils.h>

using namespace std;

using ll = long long;

vector<vector<int>> g;

int ohr[300005];
set<int> res;

void dfs(int v, int h, set<int> &used) {
    used.insert(v);
    ohr[v] = h;
    res.insert(v);
    if (h == 1) {
        return;
    }
    for (ll u: g[v]) {
        if (!used.contains(u) && ohr[u] < h - 1) {
            dfs(u, h - 1, used);
        }
    }
}

void dfs_tree(ll v, ll pr, ll h) {
    ohr[v] = h;
    if (h == 1) {
        return;
    }
    for (ll u: g[v]) {
        if (v != pr && ohr[u] < h - 1) {
            dfs_tree(u, v, h - 1);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;

    g.resize(n + 1);

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    if (n <= 2000) {
        for (int i = 0; i < k; i++) {
            int p, h;
            set<int> used;
            cin >> p >> h;
            dfs(p - 1, h + 1, used);
        }
    } else {
        for (int i = 0; i < k; i++) {
            int p, h;
            cin >> p >> h;
            dfs_tree(p - 1, -1, h + 1);
        }
    }
    cout << res.size() << endl;
    for (ll u: res) {
        cout << u + 1 << ' ';
    }
}
