#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<vector<int>> g;

int ohr[300005];

void dfs(int v, int h, set<int> &used) {
    used.insert(v);
    ohr[v] = h;
    if (h == 1) {
        return;
    }
    for (ll u: g[v]) {
        if (!used.contains(u) && ohr[u] < h - 1) {
            dfs(u, h - 1, used);
        }
    }
}

void dfs_tree(ll v, ll pr, ll h) {
    ohr[v] = h;
    if (h == 1) {
        return;
    }
    for (ll u: g[v]) {
        if (v != pr && ohr[u] < h - 1) {
            dfs_tree(u, v, h - 1);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;

    g.resize(n + 1);
    vector<pair<int, int>> data;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        ohr[p - 1] = h;
        data.push_back(pair(p, h));
    }
    sort(data.begin(), data.end());
    reverse(data.begin(), data.end());
    if (n <= 2000) {
        for (auto p: data) {
            set<int> used;
            dfs(p.first - 1, p.second + 1, used);
        }
    } else {
        for (auto p: data){
            if (ohr[p.first - 1] >= p.second) continue;
            dfs_tree(p.first - 1, -1, p.second + 1);
        }
    }
    set<int> res;
    for (int i = 0; i < n; i++) {
        if (ohr[i]) {
            res.insert(i);
        }
    }
    cout << res.size() << endl;
    for (ll u: res) {
        cout << u + 1 << ' ';
    }
}