#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<unordered_set<int>> g;

int ohr[300030];

void dfs(int v, int h) {
    ohr[v] = h;
    if (h == 1) {
        return;
    }
    for (ll u: g[v]) {
        if (ohr[u] < h - 1) {
            dfs(u, h - 1);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    g.resize(n + 5);
    vector<pair<int, int>> data;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        ohr[p - 1] = h;
        data.emplace_back(p, h);
    }
    for (auto p: data) {
        dfs(p.first - 1, p.second + 1);
    }
    set<int> res;
    for (int i = 0; i < n; i++) {
        if (ohr[i]) {
            res.insert(i);
        }
    }
    cout << res.size() << endl;
    for (ll u: res) {
        cout << u + 1 << ' ';
    }
}
