#include <bits/stdc++.h>

using namespace std;

using ll = long long;

unordered_map<int, vector<int>> g;

int ohr[200010];

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, k;
    cin >> n >> m >> k;
    set<int> res;
    vector<pair<int, int>> data;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        g[a - 1].push_back(b - 1);
        g[b - 1].push_back(a - 1);
    }
    for (int i = 0; i < k; i++) {
        int p, h;
        cin >> p >> h;
        ohr[p - 1] = h;
        data.emplace_back(p, h);
    }
    sort(data.begin(), data.end());
    reverse(data.begin(), data.end());
    queue<pair<int, int>> bfs;
    for (auto p: data) {
        if (ohr[p.first - 1] > p.second) continue;
        bfs.push(pair(p.first - 1, p.second + 1));
        while (!bfs.empty()) {
            int v = bfs.front().first;
            int h = bfs.front().second;
            bfs.pop();
            ohr[v] = h;
            res.insert(v);
            for (ll u: g[v]) {
                if (ohr[u] < h - 1) {
                    bfs.emplace(pair(u, h - 1));
                }
            }
        }
    }
    cout << res.size() << endl;
    for (ll u: res) {
        cout << u + 1 << ' ';
    }
}
