#include <bits/stdc++.h>
#include <pstl/utils.h>

using namespace std;

using ll = long long;

vector<set<ll>> g;

ll ohr[300005];

void dfs(ll v, ll h, set<ll> &used) {
    used.insert(v);
    ohr[v] = h;
    if (h == 1) {
        return;
    }
    for (ll u : g[v]) {
        if (!used.contains(u) && ohr[u] < h - 1) {
            dfs(u, h - 1, used);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, m, k;
    cin >> n >> m >> k;

    g.resize(n + 1);

    for (ll i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        g[a - 1].insert(b - 1);
        g[b - 1].insert(a - 1);
    }

    for (ll i = 0; i < k; i++) {
        ll p, h;
        set<ll> used;
        cin >> p >> h;
        dfs(p - 1, h + 1, used);
    }
    ll ans = 0;
    set<ll> res;
    for (ll i = 0; i < n + 1; i++) {
        if (ohr[i]) {
            ans++;
            res.insert(i);
        }
    }
    cout << ans << endl;
    for (ll u : res) {
        cout << u + 1 << ' ';
    }
}